// SlControl.h: interface for the CSlControl class.
//
//////////////////////////////////////////////////////////////////////
#pragma warning (disable: 4786)
#if !defined(AFX_SLCONTROL_H__E5C7A0F3_1313_4018_93A4_31717E85D645__INCLUDED_)
#define AFX_SLCONTROL_H__E5C7A0F3_1313_4018_93A4_31717E85D645__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IControl.h"
#include "Slpara.h"
#include "IComm.h"
#include <utility>
#include "MainDlg.h"
#include <string>
#include <queue>

#define NUM_PORT_BITS 8
#define MAX_SL_OUT_CHARS 10

using namespace std ;

class CSlControl : public IControl
{
public:
	void CheckTimeout();
	void CalibrateMotor(char motor, string position);
	void SelectDestination(string response);
	CSlControl(CMainDlg *maindlg, CSerialParaDlg *pCommsDlg, CSlParaDlg *pParaDlgA, CSlParaDlg *pParaDlgB,
		CSlParaDlg *pParaDlgC);
	~CSlControl();
	
	CMainDlg* m_pMain;
	CSerialComm* m_pComms;
	CSlPara* m_pSlPara;

	void StartMotor(char Motor, string Position);
	void StopMotor(char Motor);
	void SetParameters(char motor, bool vel);
	void ReadMotorStatus(string Motor);
	void SetMotorToZero(char Motor);
	void MotorPower(bool status);

	void InitComms();
	void InitController();
	void CloseComms();
	BOOL IsConnectionReady();
	void ReadControllerStatus(string sPort);
	void SetControllerOutOn(int nOutput);
	void SetControllerOutOff(int nOutput);
	void SendToController(string Line,string sender);
	void ReadResponse();
private:
	string response;
	queue< pair<string,SYSTEMTIME> > commandqueue;
};

#endif // !defined(AFX_SLCONTROL_H__E5C7A0F3_1313_4018_93A4_31717E85D645__INCLUDED_)
